package org.foxarmy.barcodescannerforemployees.activities

import android.content.Intent
import android.os.Bundle
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.security.crypto.EncryptedSharedPreferences
import androidx.security.crypto.MasterKeys
import org.foxarmy.barcodescannerforemployees.Net
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.databinding.ActivityLoginBinding

class LoginActivity : AppCompatActivity() {

    private lateinit var binding: ActivityLoginBinding;

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityLoginBinding.inflate(layoutInflater);
        setContentView(binding.root)

        val masterKeyAlias = MasterKeys.getOrCreate(MasterKeys.AES256_GCM_SPEC)

        val sharedPreferences = EncryptedSharedPreferences.create(
            "sensitive",
            masterKeyAlias,
            applicationContext,
            EncryptedSharedPreferences.PrefKeyEncryptionScheme.AES256_SIV,
            EncryptedSharedPreferences.PrefValueEncryptionScheme.AES256_GCM
        )

        binding.loginButton.setOnClickListener {
            val server = binding.serverTextEdit.text.toString()
            val username = binding.usernameTextEdit.text.toString()
            val password = binding.passwordTextEdit.text.toString()

            val n = Net()

            val response = n.login(server, username, password)
            //TODO: handle it properly when server will support Accept-Language header
            if (response == "Wrong password") {
                Toast.makeText(this, getString(R.string.wrong_password), Toast.LENGTH_SHORT).show()
            } else {
                sharedPreferences.edit().putString("token", response).apply()
                val intent = Intent(this, MainActivity::class.java)
                startActivity(intent)
                finish()
            }
        }

        binding.registerButton.setOnClickListener {
            val server = binding.serverTextEdit.text.toString()
            val username = binding.usernameTextEdit.text.toString()
            val password = binding.passwordTextEdit.text.toString()

            val n = Net()

            val response = n.registerAccount(server, username, password);
            //TODO: handle it properly when server will support Accept-Language header
            if (response == "Such username exists") {
                Toast.makeText(this, getString(R.string.username_already_exists), Toast.LENGTH_SHORT).show();
            } else {
                sharedPreferences.edit().putString("token", response).apply()
                sharedPreferences.edit().putString("server", server).apply()
                val intent = Intent(this, MainActivity::class.java)
                startActivity(intent)
                finish()
            }

        }


    }

}